#include "../w95k.h"

HAB habMain;
HWND hwndMain, hwndClient;
HINI hiniFile;
HMTX hmtxProcEventSem;

int main (int argc, char * argv[])
{ ULONG CreateFlags=FCF_TITLEBAR | FCF_SYSMENU | FCF_MENU | FCF_SIZEBORDER | FCF_MINMAX | FCF_ICON | FCF_ACCELTABLE | FCF_TASKLIST ;
  HMQ hmqMain;
  QMSG Message;
  BOOL bRes;

  habMain=WinInitialize(0);
  if(!habMain)
    { BeepBeep(1);
      return(1);
    }

  printf("%s\n", VERSION);
  setbuf(stdout, NULL);
  setbuf(stderr, NULL);

  hmqMain=WinCreateMsgQueue(habMain, 0);
  if(!hmqMain)
    { BeepBeep(2);
      WinTerminate(habMain);
      return(2);
    }

  bRes=WinRegisterClass(habMain, "Win95keyWindoClass", w95kWindowProc, CS_SIZEREDRAW, 0);
  if(!bRes)
    { BeepBeep(3); 
      WinPerror("Error", "Error while registering window class");
      return(3);
    }

  ProfileQueryParams();  

  hwndMain=WinCreateStdWindow(HWND_DESKTOP, WS_ANIMATE, &CreateFlags, "Win95keyWindoClass", "Win95key", 0L, (HMODULE)NULL, 1, &hwndClient);
  if(hwndMain==NULLHANDLE)
    { WinPerror("Error", "Error while creating window");
      return(4);
    }

  WinSetWindowPos(hwndMain, HWND_TOP, mainParams.x, mainParams.y, mainParams.cx, mainParams.cy, SWP_SIZE|SWP_MOVE|SWP_ZORDER|SWP_ACTIVATE);
  if(mainParams.isMinimized)
    { WinSetWindowPos(hwndMain, 0, 0, 0, 0, 0, SWP_MINIMIZE);
    }
   else
    { WinSetWindowPos(hwndMain, HWND_TOP, mainParams.x, mainParams.y, mainParams.cx, mainParams.cy, SWP_SHOW);
    }
  WinSetWindowText(hwndMain, "Win95key");

  if(w95kStartup(1)!=0)
    { WinPerror("Error", "Error while initializing application");
      return(5);
    }

  while(WinGetMsg(habMain, &Message, (HWND)NULL, 0, 0 ))
   { WinDispatchMsg(habMain, &Message);
   }
  WinPostMsg(hwndMain, WM_SHOW, MPFROMLONG(0l), MPFROMLONG(0l));

  w95kShutdown(1);
  
  DosCloseMutexSem(hmtxProcEventSem);
  
  WinDestroyMsgQueue(hmqMain);
  WinTerminate(habMain);

  return(0);
}




